/*
 * Sonar, entreprise quality control tool.
 * Copyright (C) 2007-2008 Hortis-GRC SA
 * mailto:be_agile HAT hortis DOT ch
 *
 * Sonar is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * Sonar is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with Sonar; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02
 */
package org.sonar.maven;

import ch.hortis.sonar.model.ProjectMeasure;
import ch.hortis.sonar.model.Rule;
import ch.hortis.sonar.model.RuleFailure;
import ch.hortis.sonar.model.RuleFailureLevel;
import ch.hortis.sonar.model.RuleFailureParam;
import ch.hortis.sonar.model.SnapshotSource;
import ch.hortis.sonar.service.MeasureKey;

public interface MeasuresRecorder {
  void start();

  void stop();

  ProjectMeasure createProjectMeasure(MeasureKey key, Double value);

  ProjectMeasure createPackageMeasure(String packageName, MeasureKey key, Double value);

  ProjectMeasure createClassMeasure(String packageName, String className, boolean unitTest, MeasureKey key, Double value);

  RuleFailure createClassRuleFailure(Rule rule, String packageName, String className, boolean unitTest, String message, RuleFailureLevel level, RuleFailureParam... params);

  SnapshotSource createClassSource(String packageName, String className, String source, boolean unitTest);
}
